

;/-------------------------\
;-       Constantes
;\-------------------------/



#Vector_ErrorTitle      = "UserLib Vector Error"
#Vector_Flag_Allocated  = $4AB3   ; a fixed random value
#Vector_CurrentElement  = -2      ; Default value for empty parameter in Select, Add, Delete Functions
#Vector_NewLine         = #CR$    ; NewLine Caracter for Vector_Debug

;{- Type Enumeration
;   Kind of vector : differents types
  #VType_ComplexStructure = -2 ; Complex structure (contains pointer to other structures, as strings)
  #VType_SimpleStructure  = -1 ; Simple structure
 #Byte    =  0
 #Word    =  1
 #Long    =  2
 #Float   =  3
 #Quad    =  4
 #String  =  5
 #Double  =  6
  #Vector_Type_Minimum = #VType_ComplexStructure
  #Vector_Type_Maximum = #Double
;}


;{- Sort Enumeration
; Sort and comparisons
  #Vector_Sort_Downward         = $20
  ;#Vector_Sort_CaseNotSensitive = $40 ; For Strings
  ;{- EncType Enumeration
  ; String encodage
    #Vector_Compare_Ascii       = $00
    #Vector_Compare_UTF8        = $01
    #Vector_Compare_Unicode     = $02
  ;}
;}


;{- Comparator Enumeration
; comparisons
  #Vector_Compare_Less        = -1
  #Vector_Compare_Equal       =  0
  #Vector_Compare_More        =  1
;}


;{- ScanDirectory Enumeration
  #Vector_Dir_Recursive       = 1
  #Vector_Dir_KeepFolder      = 2
;}

  
;- SortFiles Enumeration
; sort files
  Enumeration 
    #Vector_Sort_Name_Upward
    #Vector_Sort_Name_Downward
    #Vector_Sort_FileSize_Upward
    #Vector_Sort_FileSize_Downward
    #Vector_Sort_DateCreated_Upward
    #Vector_Sort_DateCreated_Downward
    #Vector_Sort_DateAccessed_Upward
    #Vector_Sort_DateAccessed_Downward
    #Vector_Sort_DateModified_Upward
    #Vector_Sort_DateModified_Downward
  EndEnumeration
;}  
  

;/-------------------------\
;-       Structures
;\-------------------------/



;{- Structure VNode
;   VNode Structure (Vector Nodes)
;   Object who contains the pointer to the Data
Structure VNode

  *Value                    ; Address of the Element
  *NextElement.VNode        ; Pointer to the next element
  *PreviousElement.VNode    ; Pointer to the previous element
  
EndStructure
;}


;{- Structure Vector
;   Vector Structure
;   Main Object : contains information about the linked list
Structure Vector

  Initilized.w              ; Flag for beeing sure that the Vector is allocated
  
  Type.w                    ; Kind of Vector
  
  Size.l                    ; If Type is Simple, size must have the value of SizeOf(Struct)
                            ; by this way, a generic con/destructor will be associate
  
  *Constructor              ; Address of the constructor function
  *Destructor               ; Address of the destructor function
  *Comparator               ; Pointer to the comparate function
  
  *CurrentElement.VNode     ; Pointer to the current element
  *FirstElement.VNode       ; Pointer to the first element of the Vector
  *LastElement.VNode        ; Pointer to the last element of the Vector
  Index.l                   ; Index of the current element
  
  Count.l                   ; Number of element in this vector

  Mutex.l                   ; Create a Mutex for ThreadSafe Vector
  
EndStructure
;}


;{- Structure Vector_FileInfos
;   Used for advanced information when scanning directories
Structure Vector_FileInfos
  ShortFileName.s
  CompleteFileName.s
  DateCreated.l
  DateAccessed.l
  DateModified.l
  FileSize.q
  CustomData.l    ; Put whatever you want here !
EndStructure
;}



CompilerSelect #PB_Compiler_OS
  CompilerCase #PB_OS_Windows
    #PATH_DELIMITER = "\"
  CompilerDefault
    #PATH_DELIMITER = "/"
    ; This include Mac, Linux and Amiga OS
    ;   But I don't know if it's true...
CompilerEndSelect




; IDE Options = PureBasic 4.10 Beta 4 (Windows - x86)
; CursorPosition = 32
; FirstLine = 18
; Folding = --
; UseMainFile = Vector.pb4
; IDE Options = PureBasic 4.30 Beta 3 (Windows - x86)
; CursorPosition = 17
; Folding = --